/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "pim/ActionLog.h"

BOOL ActionLog::debugEnabled = false;

wchar_t ActionLog::actionPath[DIM_PATH];
wchar_t ActionLog::wfilename [DIM_FILE];
FILE* ActionLog::logFile;

ActionLog ActionLOG = ActionLog(true);  


ActionLog::ActionLog(BOOL reset) {
        
}

void ActionLog::open(BOOL reset) {      
    wsprintf(wfilename, TEXT("%s/%s"), actionPath, ACTION_LOG_NAME);
        
    logFile = _wfopen(wfilename, (reset) ? TEXT("w+") : TEXT("a+"));
}

ActionLog::~ActionLog() {
    if (logFile != NULL) {
        fclose(logFile);
    }
}

void ActionLog::error(const wchar_t* msg) {
    printMessage(ACTION_LOG_ERROR, msg);
}

void ActionLog::info(const wchar_t* msg) {
    printMessage(ACTION_LOG_INFO, msg);
}

void ActionLog::debug(const wchar_t* msg) {
    if (debugEnabled == TRUE) {
        printMessage(ACTION_LOG_DEBUG, msg);
    }
}

void ActionLog::action(const wchar_t* msg) {
    if (debugEnabled == TRUE) {
        printMessage(ACTION_LOG_ACTION, msg);
    }
}

void ActionLog::setDebug(BOOL enabled) {
    debugEnabled = enabled;
}


void ActionLog::setActionPath(wchar_t* path) {
        
        if (path != NULL)
            wsprintf(actionPath, TEXT("%s"), path);
        else
            wsprintf(actionPath, TEXT("%s"), TEXT(""));
}

BOOL ActionLog::isDebug() {
    return debugEnabled;
}

void ActionLog::printMessage(const wchar_t* level, const wchar_t* msg) {
    if (logFile != NULL) {
        if (wcscmp(level, ACTION_LOG_ACTION) == 0) 
            fwprintf(logFile, TEXT("%s\n"), msg); 
            
        else
            fwprintf(logFile, TEXT("%s - %s\n"), level, msg); 

        fflush(logFile);
    }
}