/*
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "pim/Container.h"
#include "base/util/utils.h"
#include "base/Log.h"


Container::Container() {
    allItems = new ArrayList();
    newItems = new ArrayList();
    updatedItems = new ArrayList();
    deletedItems = new ArrayList();
}

Container::~Container() {
    allItems->clear();
    newItems->clear();
    updatedItems->clear();
    deletedItems->clear();
}
/**
* Function for ALL ITEMS ArrayList
*/

void Container::addItemToAllItems(SyncItem* syncItem) {
    if (syncItem == NULL)
        return;
    allItems->add(*syncItem);
}

int Container::getAllItemsSize() {    
    return allItems->size();
}

void Container::resetAllItems() {
    allItems->clear();
}

ArrayList* Container::getAllItems() {
    return allItems;
}

/**
* Function for NEW ITEMS ArrayList
*/
void Container::addItemToNewItems(SyncItem* syncItem) {
    if (syncItem == NULL)
        return;
    newItems->add(*syncItem);
}

int Container::getNewItemsSize() {
    return newItems->size();
}

void Container::resetNewItems() {
    newItems->clear();
}


ArrayList* Container::getNewItems() {
    return newItems;
}

/**
* Function for UPDATED ITEMS ArrayList
*/
void Container::addItemToUpdatedItems(SyncItem* syncItem) {
    if (syncItem == NULL)
        return;
    updatedItems->add(*syncItem);
}

int Container::getUpdatedItemsSize() {
    return updatedItems->size();
}

void Container::resetUpdatedItems() {
    updatedItems->clear();
}


ArrayList* Container::getUpdatedItems() {
    return updatedItems;
}

/**
* Function for DELETED ITEMS ArrayList
*/
void Container::addItemToDeletedItems(SyncItem* syncItem) {
    if (syncItem == NULL)
        return;
    deletedItems->add(*syncItem);
}

int Container::getDeletedItemsSize() {
    return deletedItems->size();
}

void Container::resetDeletedItems() {
    deletedItems->clear();
}


ArrayList* Container::getDeletedItems() {
    return deletedItems;
}


