/*
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "base/util/utils.h"
#include "pim/mail/MailClientData.h"

MailClientData::MailClientData(const wchar_t *id) {
    entryId = wstrdup(id);
    folder = NULL;
    emailData = new EmailData();
}

MailClientData::~MailClientData() {   
    if (folder)
        delete [] folder;
    if (entryId)
        delete [] entryId;
    delete emailData;
    emailData = NULL;

}

void MailClientData::setEmailData(EmailData* t) {
    if (emailData) {
        delete emailData;
    }
    emailData = (EmailData*)t->clone();
}

EmailData* MailClientData::getEmailData() const {
    return emailData;
}

const wchar_t * MailClientData::getEntryId() const {
    return entryId;
}

void MailClientData::setParent(const wchar_t* t) {
    if (folder)
        delete [] folder;
    folder = wstrdup(t);
}

void MailClientData::setParent(wchar_t t) {
    if (folder)
        delete [] folder;

    folder = new wchar_t[2];
    wsprintf(folder, TEXT("%c"), t);
}

const wchar_t* MailClientData::getParent() const {
    return folder;
}
