/*
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "pim/mail/MailExtraData.h"

//-------------------------------------------------------------- Contructors

MailExtraData::MailExtraData() {
    id = NULL;
    messageId = NULL;
    extraHeaders = NULL;
}

MailExtraData::MailExtraData(MailExtraData &other) {
    id = stringdup(other.id);
    messageId = stringdup(other.messageId);
    extraHeaders = stringdup(other.extraHeaders);
}

MailExtraData::~MailExtraData() {
    safeDelete(&id);    
    safeDelete(&messageId);    
    safeDelete(&extraHeaders);
}

//-------------------------------------------------------------- Accessor methods

void MailExtraData::setId(const char* t) {
    safeDelete(&id);
    id = stringdup(t);
}

const char* MailExtraData::getId() const {
    return id;
}

void MailExtraData::setMessageId(const char* t) {
    safeDelete(&messageId);
    messageId = stringdup(t);
}

const char* MailExtraData::getMessageId() const {
    return messageId;
}


void MailExtraData::setHeaders(const char *t) {    
    safeDelete(&extraHeaders);
    extraHeaders = stringdup(t);    
}


const char* MailExtraData::getHeaders() const {
    return extraHeaders;
}

//-------------------------------------------------------------- Public methods

MailExtraData& MailExtraData::operator=(MailExtraData &other) {
    if(this != &other){
        setId(other.id);
        setMessageId(other.messageId);
        setHeaders(other.extraHeaders);
    }
    return *this;
}

ArrayElement* MailExtraData::clone() {
    MailExtraData* ret = new MailExtraData(*this);
    return ret;
}
