/*
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "pim/mail/MailItem.h"

//-------------------------------------------------------------- Contructors
MailItem::MailItem() {
    id = 0;
    read = FALSE;
    folder = 0;
}

MailItem::MailItem(MailItem & other) {
    id = stringdup(other.id);
    read = other.read;
    folder = stringdup(other.folder);
}

MailItem::~MailItem() {
    safeDelete(&id);    
}

//----------------------------------------------------------- Accessor methods
void MailItem::setId(const char* t) {
    safeDelete(&id);
    id = stringdup(t);
}

const char* MailItem::getId() {
    return id;
}

void MailItem::setRead(const char* t) {
    if( strcmp(t, "0") == 0 )
        read = false;
    else
        read = true;
}

void MailItem::setRead(bool t) {
    read = t;
}

bool MailItem::getRead() {
    return read;
}

void MailItem::setFolder(const char* t) {
    safeDelete(&folder);
    folder = stringdup(t);
}

const char* MailItem::getFolder() {
    return folder;
}

MailItem & MailItem::operator=(MailItem & other) {
    if(this != &other) {
        setId(other.id);
        setRead(other.read);
        setFolder(other.folder);
    }
    return *this;
}

ArrayElement* MailItem::clone() {
    MailItem* ret = new MailItem(*this);
    return ret;
}
