/*
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef INCL_MAIL_EXTRA_DATA
    #define INCL_MAIL_EXTRA_DATA

#include "base/util/ArrayElement.h"
#include "base/util/utils.h"
#include "base/Log.h"
#include "base/util/StringBuffer.h"


/**
* This class represents the mail extra data inside the cache file that contains the current 
* elements into all folder
*/
   
class MailExtraData: public ArrayElement {

    private:
      
        /*
         * The id of the message. It is b64 coded
         */
        char* id;
        
        /*
         * The message identifier that doesn't appear into ppc mail
         */
        char* messageId;
        /*
        * Extra e-mail Headers
        */
        char* extraHeaders;

    public:
    
        MailExtraData();
        MailExtraData(MailExtraData &other);
        ~MailExtraData();

        void setId(const char* t);
        const char* getId() const;

        void setMessageId(const char* t);
        const char* getMessageId() const;

        void setHeaders(const char *t);
        const char* getHeaders() const;


        MailExtraData& operator=(MailExtraData &other);

        ArrayElement* clone();
};

#endif

