/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef INCL_MAIL_SERVER2CLIENT
#define INCL_MAIL_SERVER2CLIENT

#include "base/fscapi.h"
#include "base/util/ArrayList.h"
#include "base/util/ArrayElement.h"
#include "pim/mail/MailInfo.h"
#include "pim/mail/MailClientData.h"
#include "pim/utils.h"
#include "spds/constants.h"
#include "spds/SyncItem.h"
#include "spds/MailMessage.h"
#include "spds/constants.h"
#include "pim/mail/MailUtils.h"

#include <mapidefs.h>
#include <mapicode.h>
#include <mapitags.h>
#include <mapix.h>
#include <mapiutil.h>
#include <cemapi.h>

/*
#define MSGFLAG_READ            ((ULONG) 0x00000001)
#define MSGFLAG_UNMODIFIED      ((ULONG) 0x00000002)
#define MSGFLAG_SUBMIT          ((ULONG) 0x00000004)
#define MSGFLAG_UNSENT          ((ULONG) 0x00000008)
#define MSGFLAG_HASATTACH       ((ULONG) 0x00000010)
#define MSGFLAG_FROMME          ((ULONG) 0x00000020)
#define MSGFLAG_ASSOCIATED      ((ULONG) 0x00000040)
#define MSGFLAG_RESEND          ((ULONG) 0x00000080)
#define MSGFLAG_RN_PENDING      ((ULONG) 0x00000100)
#define MSGFLAG_NRN_PENDING     ((ULONG) 0x00000200)
*/

class MailServer2Client{

private:
    /**
     * folder to sync.
     * It keeps a copy of folder to sync from sync source
     */
    wchar_t* server_folderToSync;

    /*
     * Avoid object copy
     */
    MailServer2Client(MailServer2Client& o);
    MailServer2Client& operator=(MailServer2Client& o);
    void bt2ft(const BasicTime& b, FILETIME& f);

public:

    MailServer2Client();    
    ~MailServer2Client() ;     
    
    void setFolderToSync(const wchar_t* t);
    const wchar_t* getFolderToSync();

    /*
     * number of folder to sync
     */
    int folderNumber;
    
    HRESULT SetMessageProps(IMAPISession* pSession, LPMESSAGE pmsg, MailClientData* m, BOOL onlyFlags = false);
    HRESULT SetMessageRecipients (LPMESSAGE pmsg, MailClientData* m);
    //static void AddRecipients(LPWSTR pszSrc, ULONG ulType, ADRLIST* plst, LPWSTR& pszLocalRecips, LPSPropValue& pval);
    //ULONG CountRecipsInString(LPCWSTR psz);
    HRESULT AddAttachment(LPMESSAGE pmsg, MailClientData* m);

    /*
    * check by message-id of the mail if arleady exists in the folder.
    * The message-id is a custom property into email item
    */
    bool doesMessageExist (const char* msgID, LPMAPIFOLDER pfldrInbox);
    bool messageExistInOubox_deleteIt(IMsgStore* pStore, IN const char* msgid);

    wchar_t* addMessage(MailClientData* m);
    HRESULT  updateMessage(MailClientData* m);
    HRESULT  deleteMessage(MailClientData* m);



};

#endif
