; NOTE: this .NSI script is designed for NSIS v1.8+

Name "Funambol Windows Mobile Plug-in ${VERSION_NUMBER}"
Icon "install.ico"
OutFile "fileNameToRename.exe"

InstallDir "$PROGRAMFILES\Funambol\clients\Windows Mobile Plug-in"
InstallDirRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Funambol\Windows Mobile Plug-in" "" 

Function .onInit
      MessageBox MB_OKCANCEL "It is strongly recommended to uninstall any previous installed Funambol clients before continuation." IDOK continue
      Abort
      
      continue:
      
FunctionEnd

Section "Funambol Lib"

  SetOutPath "$INSTDIR"

  File SetupLib.ini
  File "Funambol lib.Arm 1100 (4K) v3.00.CAB"

; one-time initialization needed for InstallCAB subroutine
  ReadRegStr $1 HKEY_LOCAL_MACHINE "software\Microsoft\Windows\CurrentVersion\App Paths\CEAppMgr.exe" ""
  IfErrors Error
   Goto End

Error:
   MessageBox MB_OK|MB_ICONEXCLAMATION \
                   "Unable to find Application Manager for PocketPC applications. \
                   Please install ActiveSync and reinstall YourApp."
End:

  StrCpy $0 "$INSTDIR\SetupLib.ini"
  Call InstallCAB

SectionEnd ; end of section 'Optional'

Section "RunTimeVB"
  SectionIn 1
  SetOutPath "$INSTDIR"

  File SetupRuntimeVB.ini
  File msvbppc.armv4.cab

  StrCpy $0 "$INSTDIR\SetupRuntimeVB.ini"
  Call InstallCAB

SectionEnd ; end of section 'Optional'


Section "Funambol Windows Mobile Plug-in" ; (default, requried section)
  SetOutPath "$INSTDIR"

  File SetupWMPlugin.ini
  File "Funambol Windows Mobile Plug-in.Arm 1100 (4K) v3.00.CAB"

  StrCpy $0 "$INSTDIR\SetupWMPlugin.ini"
  Call InstallCAB

SectionEnd ; end of default section



Section "-post" ; (post install section, happens last after any optional sections) ; add any commands that need to happen after any optional sections here

  SetOutPath "$INSTDIR"
  Delete "$INSTDIR\*.*"
  RMDir /r "$INSTDIR"


SectionEnd ; end of -post section

ShowInstDetails nevershow ;never show installation details

; Installs a PocketPC cab-application
; It expects $0 to contain the absolute location of the ini file 
; to be installed.
Function InstallCAB

  ExecWait '"$1" "$0"'

FunctionEnd


; eof
