/*
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include "stdafx.h"
#include "setup.h"
#include "ce_setup.h"
#include <cfgmgrapi.h>
#include "Tlhelp32.h"
#include "mail.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CSetupApp

BEGIN_MESSAGE_MAP(CSetupApp, CWinApp)
	//{{AFX_MSG_MAP(CSetupApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupApp construction

CSetupApp::CSetupApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSetupApp object

CSetupApp theApp;


///////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////
////////////////
////////////////   FUNAMBOL MODIFICATION FOR CAB INSTALLATION
////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////

#define PROGRAM_DIR TEXT("Funambol")

#define ACCOUNT L"<wap-provisioningdoc> \
                    <characteristic type=\"EMAIL2\"> \
                      <characteristic type=\"{F9043C85-F6F2-101A-A3C9-08002B2F49FB}\"> \
                         <parm name=\"SERVICENAME\" value=\"Funambol\"/> \
                         <parm name=\"SERVICETYPE\" value=\"Funambol\"/> \
                         <parm name=\"INSERVER\"    value=\"sync.funambol.com\"/> \
                         <parm name=\"OUTSERVER\"   value=\"sync.funambol.com\"/> \
                         <parm name=\"AUTHNAME\"    value=\"username\"/> \
                         <parm name=\"AUTHSECRET\"  value=\"password\"/> \
                         <parm name=\"DOMAIN\"      value=\"funambol.com\"/> \
                         <parm name=\"REPLYADDR\"   value=\"test.user@somewhere.com\"/> \
                         <parm name=\"NAME\"        value=\"Test User\"/> \
                       </characteristic> \
                     </characteristic> \
                  </wap-provisioningdoc>"

/*
#define ACCOUNT_DEL L"<wap-provisioningdoc>\
                    <characteristic type=\"EMAIL2\">\
                    <nocharacteristic type=\"F9043C85-F6F2-101A-A3C9-08002B2F49FB\"/>\
                    </characteristic>\
                    </wap-provisioningdoc>\
                "
*/

const wchar_t* acc  = TEXT("<wap-provisioningdoc><characteristic type=\"EMAIL2\"><nocharacteristic type=\"%s\"/></characteristic></wap-provisioningdoc>");

#define ACCOUNT_QUERY L"<wap-provisioningdoc>\
                    <characteristic type=\"EMAIL2\">\
                       <characteristic-query type=\"{F9043C85-F6F2-101A-A3C9-08002B2F49FB}\"/>\
                    </characteristic>\
                    </wap-provisioningdoc>\
                "

#define MSG_BEFORE_UNINSTALL TEXT("Do you want to keep the emails for the next Funambol Windows Plug-in installation?")

#define FILE1 TEXT("mails_I")
#define FILE2 TEXT("mails_O")
#define FILE3 TEXT("mails_D")
#define FILE4 TEXT("mails_S")
#define FILE5 TEXT("mails_T")
#define FILE6 TEXT("appointments.dat")
#define FILE7 TEXT("contacts.dat")
#define FILE8 TEXT("notes.dat")
#define FILE9 TEXT("tasks.dat")
#define FILE10 TEXT("briefcase.dat")
#define FILE11 TEXT("favorites.dat")

#define FILE12 TEXT("\\AccountLog.txt")
#define FILE13 TEXT("\\synclog.txt")
#define FILE14 TEXT("\\notlstnr.txt")


int ret = 0;

// retrieve the Funambol program path and set it in a static
// buffer. Return the buffer
const wchar_t *getProgramPath()
{
    static wchar_t path[MAX_PATH] = TEXT("");

    if (!path[0]) {
        SHGetSpecialFolderPath(NULL, path, CSIDL_PROGRAM_FILES , FALSE);
        wcscat(path, TEXT("\\"));
        wcscat(path, PROGRAM_DIR);
    }
    return path;
}

/**
 * Start a command in a new process and return the pid
 * or 0 in case of error.
 */
unsigned long startprogram(const wchar_t *app, const wchar_t *cmdline) 
{
    const wchar_t *path = getProgramPath();
    PROCESS_INFORMATION procinfo;
    
    wchar_t *cmd = new wchar_t[wcslen(path)+wcslen(app)+5];
    wsprintf(cmd, TEXT("%s/%s"), path, app);
   
    if( CreateProcess( cmd, cmdline, 
                       NULL, NULL, FALSE, 0,
                       NULL, NULL, NULL, &procinfo ) ) {
        return procinfo.dwProcessId; 
    }
    else
        return 0;
}


void createAccount() {
    LPWSTR out = NULL;  
    wchar_t* ret = NULL;
    ret = getFunambolGUID();
    HRESULT hr;
    if (!ret) {        
        hr = DMProcessConfigXML(ACCOUNT, CFGFLAG_PROCESS, &out);
    } 

}

void deleteAccount(wchar_t* guid) {
    
    LPWSTR out = NULL;     
    wchar_t account[512];      
     
    memset(account, 0, 512*sizeof(wchar_t));
    wsprintf(account, acc, guid);        
    HRESULT ret = DMProcessConfigXML(account, CFGFLAG_PROCESS, &out);

}

void queryAccount() {
    LPWSTR out = NULL;    
    HRESULT ret = DMProcessConfigXML(ACCOUNT_QUERY, CFGFLAG_PROCESS, &out);
    if (out != NULL) {
        if (wcsstr(out, TEXT("Funambol")) == NULL) {   
            MessageBox (NULL, TEXT("createAccount1"), TEXT ("Debug eVC"), MB_SETFOREGROUND |MB_OK);
            createAccount();
        } else {
            MessageBox (NULL, TEXT("createAccount2"), TEXT ("Debug eVC"), MB_SETFOREGROUND |MB_OK);
            createAccount();
            
        }
    }    

}

void deregister() {    
    startprogram(TEXT("handleservice.exe"), TEXT("deregister"));
    return;
}

void deregisterSMS() {    
    startprogram(TEXT("startsync.exe"), TEXT("deregister"));
    return;
}


BOOL deleteFiles() {

    WIN32_FIND_DATA FileData;
    
    HANDLE hFind;
    wchar_t toFind    [512];
    wchar_t szNewPath [512];
    wchar_t filterPattern [256];
    wchar_t dir       [512];

    BOOL ret = TRUE;
    szNewPath[0] =   0;
    int lung = 0;
    
    DWORD dwAttrs;
    
    BOOL fFinished = FALSE;
    wcscpy(dir, getProgramPath());
    wsprintf(filterPattern, TEXT("*.*"));
   
    wsprintf(toFind, TEXT("%s/%s"), dir, filterPattern);
   
    hFind = FindFirstFile(toFind, &FileData);
      
    if (hFind != INVALID_HANDLE_VALUE) {
    
        while (!fFinished) {
                
            wsprintf(szNewPath, TEXT("%s/%s"), dir, FileData.cFileName);
			
            dwAttrs = GetFileAttributes(szNewPath);
            
            if (dwAttrs == FILE_ATTRIBUTE_DIRECTORY) { }
               
            else {
                if (   (wcsstr(szNewPath, FILE1) != NULL) ||
                       (wcsstr(szNewPath, FILE2) != NULL) || 
                       (wcsstr(szNewPath, FILE3) != NULL) || 
                       (wcsstr(szNewPath, FILE4) != NULL) || 
                       (wcsstr(szNewPath, FILE5) != NULL) || 
                       (wcsstr(szNewPath, FILE6) != NULL) || 
                       (wcsstr(szNewPath, FILE7) != NULL) || 
                       (wcsstr(szNewPath, FILE8) != NULL) || 
                       (wcsstr(szNewPath, FILE9) != NULL) || 
                       (wcsstr(szNewPath, FILE10) != NULL) || 
                       (wcsstr(szNewPath, FILE11) != NULL) 
                       ) {
                        
                        //MessageBox (NULL, szNewPath, TEXT ("Debug eVC"), MB_SETFOREGROUND |MB_OK);
                        DeleteFile(szNewPath);
                }
            }                                    
                			
            if (!FindNextFile(hFind, &FileData)) {
				if (GetLastError() == ERROR_NO_MORE_FILES) {
					fFinished = TRUE;
				}
				else  {
					return FALSE;
				}
			}                
        }
    
	    FindClose(hFind);
    }
    
    DeleteFile(FILE12);
    DeleteFile(FILE13);
    DeleteFile(FILE14);    
               
    //RemoveDirectory(dir);
    return ret;
}

BOOL deleteDirectory() {
    
    wchar_t dir       [512];   
    wcscpy(dir, getProgramPath());           
    RemoveDirectory(dir);
    return TRUE;
}

BOOL createDirectory() {
    
    wchar_t dir       [512];   
    wcscpy(dir, getProgramPath());           
    CreateDirectory(dir, NULL);
    return TRUE;
}


int closeMail() {
    DWORD out = 0;
    PROCESSENTRY32 lppe; 
    BOOL next = TRUE;
    HANDLE hProcess = 0;

    HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0); // 0 is however ignored
    
    if (hSnapshot == INVALID_HANDLE_VALUE) 
        return 0;
    
    lppe.dwSize = sizeof( PROCESSENTRY32 );

    if (!Process32First(hSnapshot, &lppe))
        return 1;

    if (wcsstr(lppe.szExeFile, TEXT("tmail.exe")) != NULL) {
        hProcess = OpenProcess(0, FALSE, lppe.th32ProcessID);
        TerminateProcess(hProcess, -1);
        goto exit;
    }
    
    do {
        next = Process32Next(hSnapshot, &lppe);

        if (!next)
            break;
        
        if (wcsstr(lppe.szExeFile, TEXT("tmail.exe")) != NULL ) {
            hProcess = OpenProcess(0, FALSE, lppe.th32ProcessID);
            TerminateProcess(hProcess, -1);
            goto exit; 
        }

    } while(next);

exit:
    CloseHandle(hSnapshot);
    CloseHandle(hProcess);
    return 0;

}

#define COPY_ERROR      -1
#define COPY_OK          0
#define BUFSZ 16000

int FileCopy ( const char *src, const char *dst ) {

char            *buf;
FILE            *fi;
FILE            *fo;
unsigned        amount;
unsigned        written;
int             result;

buf = new char[BUFSZ];

fi = fopen( src, "rb" );
fo = fopen( dst, "wb" );

result = COPY_OK;
if  ((fi == NULL) || (fo == NULL) )
  {
  result = COPY_ERROR;
  if (fi != NULL) fclose(fi);
  if (fo != NULL) fclose(fo);
  }

if (result == COPY_OK)
  {
  do
    {
    amount = fread( buf, sizeof(char), BUFSZ, fi );
    if (amount)
      {
      written = fwrite( buf, sizeof(char), amount, fo );
      if (written != amount)
        {
        result = COPY_ERROR; // out of disk space or some other disk err?
        }
      }
    } // when amount read is < BUFSZ, copy is done
  while ((result == COPY_OK) && (amount == BUFSZ));
  fclose(fi);
  fclose(fo);
  }
delete [] buf;
return(result);
}


void createRegistry() {
    
    HKEY key = NULL; 
    DWORD res;
    wchar_t port [256];
    wchar_t name [256];
    wchar_t dll [256];
    wcscpy(port, TEXT("SOFTWARE\\Microsoft\\Inbox\\Svc\\Funambol\\Port"));
    wcscpy(name, TEXT("SOFTWARE\\Microsoft\\Inbox\\Svc\\Funambol\\Name"));
    wcscpy(dll, TEXT("SOFTWARE\\Microsoft\\Inbox\\Svc\\Funambol\\DLL"));
        
    RegCreateKeyEx(
            HKEY_LOCAL_MACHINE,
            TEXT("SOFTWARE\\Microsoft\\Inbox\\Svc\\Funambol"),
            0,
            NULL,
            0,
            0,
            NULL,
            &key,
            &res
            );
    
    if (key == 0) {
        //MessageBox (NULL, TEXT("KEY null"), TEXT ("Alert"), MB_SETFOREGROUND |MB_YESNO);
    }
    RegSetValueEx(
            key,
            TEXT("port"),
            0,
            REG_SZ,  // we currently support only strings
            (UCHAR*)TEXT("0"),
            (wcslen(TEXT("0"))+1)*sizeof(wchar_t)
            );
    
    RegSetValueEx(
            key,
            TEXT("Name"),
            0,
            REG_SZ,  // we currently support only strings
            (UCHAR*)TEXT("Funambol"),
            (wcslen(TEXT("Funambol"))+1)*sizeof(wchar_t)
            );

    RegSetValueEx(
            key,
            TEXT("DLL"),
            0,
            REG_SZ,  // we currently support only strings
            (UCHAR*)TEXT("syncmltransport.dll"),
            (wcslen(TEXT("syncmltransport.dll"))+1)*sizeof(wchar_t)
            );
    
    //
    // To create the UserCannotCreate property. Currently not supported
    // 
    /*
    RegSetValueEx(
            key,
            TEXT("UserCannotCreate"),
            0,
            REG_DWORD,  // we currently support only strings
            (UCHAR*)TEXT("1"),
            (wcslen(TEXT("1"))+1)*sizeof(wchar_t)
            );
    */
    RegFlushKey(key);
  
    if (key != 0) {
        RegCloseKey(key);
    }
}

void deleteRegistry() {
    RegDeleteKey(HKEY_LOCAL_MACHINE,TEXT("SOFTWARE\\Microsoft\\Inbox\\Svc\\Funambol"));

}

codeINSTALL_INIT
Install_Init(
    HWND        hwndParent,
    BOOL        fFirstCall,
    BOOL        fPreviouslyInstalled,
    LPCTSTR     pszInstallDir
) {
    AFX_MANAGE_STATE(AfxGetStaticModuleState());

    createRegistry();
    createDirectory();

    //
    // This function could be called to force to close the email process
    //
    closeMail();

    return codeINSTALL_INIT_CONTINUE;
}

codeINSTALL_EXIT
Install_Exit(   HWND    hwndParent,
                LPCTSTR pszInstallDir,
                WORD    cFailedDirs,
                WORD    cFailedFiles,
                WORD    cFailedRegKeys,
                WORD    cFailedRegVals,
                WORD    cFailedShortcuts)  {

    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    createAccount();
    
    //queryAccount();
    return codeINSTALL_EXIT_DONE;
}

codeUNINSTALL_INIT
Uninstall_Init( HWND        hwndParent,
                LPCTSTR     pszInstallDir) {

    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    
    FileCopy("\\Windows\\syncmltransport.dll", "\\Windows\\syncmltransport2.dll");    

    closeMail();
    
    deregister();
    deregisterSMS();
    ret = MessageBox (NULL, MSG_BEFORE_UNINSTALL, TEXT ("Alert"), MB_SETFOREGROUND |MB_YESNO);
    if (ret == IDNO) {
        //MessageBox (NULL, TEXT("IDNO"), TEXT ("Debug eVC"), MB_SETFOREGROUND |MB_OK);        
        deleteFiles();
    } else {
        //MessageBox (NULL, TEXT("IDYES"), TEXT ("Debug eVC"), MB_SETFOREGROUND |MB_OK);
    }    
    
    return codeUNINSTALL_INIT_CONTINUE;

}

codeUNINSTALL_EXIT
Uninstall_Exit(HWND    hwndParent) {
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
            
    if (ret == IDNO) {
        deleteRegistry();        
        wchar_t* xx = getFunambolGUID();                
        deleteAccount(xx);   
        deleteDirectory();        

    } else {
        FileCopy("\\Windows\\syncmltransport2.dll", "\\Windows\\syncmltransport.dll");        
    }

    DeleteFile(TEXT("\\Windows\\syncmltransport2.dll"));
    return codeUNINSTALL_EXIT_DONE;
}


