/*
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef INCL_S4JPROXY
#define INCL_S4JPROXY

#include "syncml/core/SyncNotification.h"

#define RESP_OK      "200 - OK\n"
#define RESP_BADREQ  "400 - Bad Request\n"
#define RESP_INVSYNC "400 - Invalid Sync type\n"
#define RESP_BUSY    "500 - Connector busy\n"
#define RESP_GENERIC "500 - Internal error\n"
#define RESP_NULLP   "500 - Null pointer\n"

class S4JProxy{
         
    public:
        // parseMessage return codes: Error, Parse OK, Message Incomplete.
        enum RetCode { Error=-1, Ok=0, Continue=1 };

        static S4JProxy* getInstance();
        static void dispose();

        // Parse the PKG0 message and return a S4JRetCode
        RetCode parsePkg0(const char *msg, int msglen);

        // Get the return string for current status code
        const char *getResponse();

        // Start a synchronization for the syncs requested by the server
        int sync(bool debug=false);

		const wchar_t *getSyncMessage();        
        bool hasErrors();
        
    private:

        SyncNotification np;
        SN_Errors errcode;
        wchar_t *syncMessage;
        
        static S4JProxy *instance;

        S4JProxy();
        ~S4JProxy();
    };

#endif

